#ifndef __CHATLINE_H
#define __CHATLINE_H

#include <qlineedit.h>
#include <qtextedit.h>

class QPopupMenu;

class ChatLine: public QTextEdit
{
    Q_OBJECT
		
    private:	
	bool mline;
	uint maxhistory;
	int historypos;
	QStringList history;
	QPopupMenu *menu, *smilemenu;
	
	void addToHistory();
		
    protected:
	void keyPressEvent(QKeyEvent *e);
	QPopupMenu * createPopupMenu(const QPoint &pos);
    public slots:
	void sayNick(const QString &nick);
	void toggleMultiLine();
    private slots:
	void smileMenuAction(int);
	void standardMenuAction(int);
    signals:
	void sendLine();
		
    public:
	ChatLine(QWidget *parent, const char *name);
	
	~ChatLine();

	void setMultiline(bool multi);
	bool isMultiline() { return mline; }
	QString convertMsg(const QString &str);
	QStringList getHistory() const;
	
	enum 
	{
	    ID_CUT = 100,
	    ID_COPY,
	    ID_PASTE
	};
};

#endif

