#include "colordialog.h"
#include <qpainter.h>
#include <qcolor.h>

ColorDialog::ColorDialog(QWidget *parent, const char *name): QPushButton(parent, name)
{
    connect(this, SIGNAL(clicked()), this, SLOT(browseClicked()));
}

ColorDialog::~ColorDialog()
{
}

void ColorDialog::drawButtonLabel (QPainter *p)
{
   p->fillRect(5, this->height()/3, this->width() - 10, static_cast<int>(this->height()/1.5 - this->height()/3), QColor(current));
}

void ColorDialog::browseClicked()
{
    QColor c = QColorDialog::getColor( current, this );
    if ( c.isValid() ) setColor(c);
    emit colorSelected(current);
}

void ColorDialog::setColor(QColor c)
{
    current = c;
    setPaletteForegroundColor(current);
}

QColor ColorDialog::color()
{
    return current;
}
