#include "conversions.h"

Conversions::Conversions()
{
}

Conversions::~Conversions()
{
}

QString Conversions::bytes2str(Q_ULONG b)
{
    QString str;
    double tmp;
        
    if (b < 1024) str = QString::number(b) + tr(" bytes");
    else
    {
	tmp = (double)b / 1024;
	if (tmp < 1024) str = QString::number(tmp, 'f', 1) + tr(" Kb");
	else
	{
	    tmp = tmp / 1024;
	    if (tmp < 1024) str = QString::number(tmp, 'f', 1) + tr(" Mb");
	    else
	    {
		tmp = tmp / 1024;
		if (tmp < 1024) str = QString::number(tmp, 'f', 1) + tr(" Gb");
		else
		{
		    tmp = tmp / 1024;
		    str = QString::number(tmp, 'f', 1) + tr(" Tb");
		}
	    }
	}
    }
    return str;
}

QString Conversions::raw2str(const unsigned char *data, uint size)
{
    QString c, tmp;
    for (uint i = 0; i < size; i++)
    {
	c.sprintf("%02hhX", data[i]);
	tmp.append(c);
    }
    return tmp;
}

QString Conversions::ext2mime(const QString &ext)
{
    QString m;
    
    m = mimepack[0].mime;
    
    for (uint i = 0; mimepack[i].ext; i++)
	if (qstrcmp(mimepack[i].ext, ext) == 0)
	    m = mimepack[i].mime;
    
    return m;
}

QString Conversions::mime2ext(const QString &mime)
{
    QString e;
  
    e = mimepack[0].ext;
    
    for (uint i = 0; mimepack[i].ext; i++)
	if (qstrcmp(mimepack[i].mime, mime) == 0)
	    e = mimepack[i].ext;

    return e;
}
