#ifndef __CONVERSIONS_H
#define __CONVERSIONS_H

#include <qobject.h>

const struct
{
    const char *ext;
    const char *mime;
} mimepack[] = {
    {"unknowntype", "application/unknown"},
    {"avi", "video/avi"},
    {"bmp", "image/x-MS-bmp"},
    {"dat", "application/raw"},
    {"com", "application/octet-stream"},
    {"doc", "application/msword"},
    {"dtd", "text/xml"},
    {"exe", "application/octet-stream"},
    {"gif", "image/gif"},
    {"htm", "text/html"},
    {"html", "text/html"},
    {"jpg", "image/jpeg"},
    {"jpeg", "image/jpeg"},
    {"mid", "audio/midi"},
    {"midi", "audio/midi"},
    {"mov", "video/quicktime"},
    {"mpe", "video/mpeg"},
    {"mpeg", "video/mpeg"},
    {"mpg", "video/mpeg"},
    {"mp2", "audio/x-mpeg"},
    {"mp3", "audio/x-mpeg"},
    {"pcd", "image/x-photo-cd"},
    {"pct", "image/pict"},
    {"pcx", "image/pcx"},
    {"pdf", "application/pdf"},
    {"php", "text/plain"},
    {"php3", "text/plain"},
    {"pic", "image/pict"},
    {"pict", "image/pict"},
    {"png",  "image/png"},
    {"tar", "application/x-tar"},
    {"tif", "image/tiff"},
    {"tgz", "application/x-gtar"},
    {"tif", "image/tiff"},
    {"tiff", "image/tiff"},
    {"txt", "text/plain"},
    {"url", "application/internet-shortcut"},
    {"wav", "audio/x-wav"},
    {"xls", "application/vnd.ms-excel"},
    {"xml", "text/xml"},
    {"z", "application/x-compress"},
    {"zip", "application/x-zip-compressed"},
    {'\0', '\0'}
};

class Conversions: public QObject
{
    Q_OBJECT
    
public:
    Conversions();
    ~Conversions();
    
    static QString bytes2str(Q_ULONG b);
    static QString raw2str(const unsigned char *data, uint size);
    static QString mime2ext(const QString &mime);
    static QString ext2mime(const QString &ext);

};

#endif
