/****************************************************************************
                          filerecvdlg.ui.h  -  description
                             -------------------
    begin                : Fri May 5 18:15:17 EST 2006
    copyright            : (C) 2004-2007 by Sergey Litvinov
    email                : linch@adsl.by
 ****************************************************************************/

/****************************************************************************
 *                                                                         					   		*
 *   This program is free software; you can redistribute it and/or modify  		   	*
 *   it under the terms of the GNU General Public License as published by  		   	*
 *   the Free Software Foundation; either version 2 of the License, or     		   	*
 *   (at your option) any later version.                                   				   	*
 *                                                                         					   		*
 ****************************************************************************/

void FileRecvDlg::setup(const QString &sender, const QString& fname, const QString &fpath, const QString& descr, Q_ULONG fsize, bool c)
{
    setWFlags(Qt::WDestructiveClose | getWFlags());
    setCaption(sender + tr(" - file send request"));
//    SenderLabel->setText(sender);
    DescrEdit->setText(descr);
    FileNameLabel->setText(fname);
    FileSizeLabel->setText(Conversions::bytes2str(fsize));
    FilesPathEdit->setText(fpath);
    
    this->fpath = fpath;
    this->sender = sender;
    createsenderfolder = c;
}

void FileRecvDlg::browseClicked()
{
//    QString tmp = QFileDialog::getSaveFileName(fpath, tr("All files (*)"), this, 0, tr("Save as..."));
    QString tmppath = sender + "/";
    QString tmp = QFileDialog::getExistingDirectory(fpath, this, 0, tr("Save in..."));
    if (!tmp.isEmpty()) fpath = tmp;
    if (createsenderfolder) 
    {
	if (QString::compare(fpath.right(tmppath.length()), tmppath) != 0)
	fpath.append(tmppath);
    }
    FilesPathEdit->setText(fpath);
}

void FileRecvDlg::recvClicked()
{
    emit fileAccept(sender, FilesPathEdit->text(), false);
    close();
}

void FileRecvDlg::recvCancelled()
{
    emit cancelled(0);
    close();
}
