/****************************************************************************
                          filesenddlg.ui.h  -  description
                             -------------------
    begin                : Mon Jul 24 22:05:34 EST 2006
    copyright            : (C) 2004-2007 by Sergey Litvinov
    email                : linch@adsl.by
 ****************************************************************************/

/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  		   *
 *   it under the terms of the GNU General Public License as published by  		   *
 *   the Free Software Foundation; either version 2 of the License, or     		   *
 *  (at your option) any later version.                                   				   *
 ***************************************************************************/

void FileSendDlg::setup(const QString &r)
{
    receiver = r;
    setCaption(tr("Send files to ") + receiver);
    browseButtonPressed();
}

void FileSendDlg::setup(const QString &r, const QString &fn)
{
    receiver = r;
    setCaption(tr("Send files to ") + receiver);

    fnames = QStringList::split(";", fn);
    updateFilesInformation();
}

void FileSendDlg::browseButtonPressed()
{
    fnames = QFileDialog::getOpenFileNames(tr("All files (*)"), QDir::homeDirPath(), this, 0, tr("Select files"));
    updateFilesInformation();
}

void FileSendDlg::updateFilesInformation()
{
    fstr.clear();
    fsize = 0;
    QStringList errflist;
    
    for(uint i = 0; i < fnames.count(); i++)
    {
	QFileInfo fi( fnames[i] );
	if (fi.isReadable())
	{
	    fsize += fi.size();
	    fstr.append('\"' + fi.fileName() + '\"');
	}
	else
	    errflist.append(fi.fileName());
	    
    }
    if (!fstr.isEmpty()) 
    {
	FilesEdit->setText(fstr.join(" "));
	SizeLabel->setText(Conversions::bytes2str(fsize));
	DescrEdit->setFocus();
    }
    if (!errflist.isEmpty())
    {
	if (errflist.count() == 1)
	    QMessageBox::critical(0, "TriX", tr("Can't read file ") + errflist[0], tr("Close"));
	else
	    QMessageBox::critical(0, "TriX", tr("Can't read files: ") + errflist.join(", "), tr("Close"));
    }
}

void FileSendDlg::send()
{
    emit sendFiles(receiver, fnames, DescrEdit->text());
    close();
}
