/***************************************************************************
                          logs.h  -  description
                             -------------------
    begin                : Thu Sep 13 19:20:00 EST 2005
    copyright            : (C) 2004-2006 by Sergey Litvinov
    email                : linch@adsl.by
 ***************************************************************************/

/***************************************************************************
 *                                                                         					   *
 *   This program is free software; you can redistribute it and/or modify  		   *
 *   it under the terms of the GNU General Public License as published by  		   *
 *   the Free Software Foundation; either version 2 of the License, or     		   *
 *   (at your option) any later version.                                   				   *
 *                                                                         					   *
 ***************************************************************************/

#ifndef __LOGS_H
#define __LOGS_H

#include <qfile.h>
#include <qmap.h>
#include <qstringlist.h>

#define CHN_TYPE 'H'
#define MSG_TYPE 'M'
#define PRV_TYPE 'P'
#define SEPARATOR "<SEP>"
#define MSG_ABSENT '0'
#define MSG_PRESENT '1'
#define MSG_OWN '2'
#define MSG_DELETED '3'

class BoardMsg;

class Logs
{
private:
    bool board;
    bool locked;
    int maxsize;
    QFile f;
    QFile fid;
    QString path;
    QMap<char, QString> tpack;
    typedef QMap<QString, QString> SpecMap;
    typedef QMap<Q_UINT32, QString> IDMap;
    IDMap idmap;
    SpecMap specmap;
    
    void setup();
	
public:
    Logs(const QString& p, int ms, bool b);
    ~Logs();
	
    bool write(const QString &date, const QString &time, const QString &src, char type, const QString &user, const QString &txt);
    QString addBoardMsgID(const QString &uid, const QString &bids, char state);
    bool delBoardMsg(Q_UINT32 id);
    bool addBoardMsg(BoardMsg *bmsg);
    bool writeData(const QString &data);
    bool writeID();
    bool setPath(const QString& p);
    bool setMaxSize(int s);
    bool isMissed(Q_UINT32 id);
    
    QString encode(const QString &str);
    QString decode(const QString &str);
    QString getAll();
    bool writeAll(const QString &bigstr);
    
    QStringList missed();
    QStringList missed(const QString &uid);
    QStringList actMessages();
};

#endif
