/***************************************************************************
                          photoform.ui.h  -  description
                             -------------------
    begin                : Thu Nov 30 23:20:47 EST 2006
    copyright            : (C) 2004-2007 by Sergey Litvinov
    email                : linch@adsl.by
 ***************************************************************************/

/***************************************************************************
 *                                                                         					   *
 *   This program is free software; you can redistribute it and/or modify  		   *
 *   it under the terms of the GNU General Public License as published by  		   *
 *   the Free Software Foundation; either version 2 of the License, or     		   *
 *   (at your option) any later version.                                   				   *
 *                                                                         					   *
 ***************************************************************************/

void PhotoForm::setImage(const QImage &img)
{
    QPixmap p;
    if (!img.isNull()) 
    {
	p.convertFromImage( img );
	if ( !p.mask() )
	    if ( img.hasAlphaBuffer() ) {
	    QBitmap bm;
	    bm = img.createAlphaMask();
	    p.setMask( bm );
	} else {
	    ;
//	    QBitmap bm;
//	    bm = img.createHeuristicMask();
//	    p.setMask( bm );
	}
	
	setBackgroundPixmap( p );
	setFixedSize( p.size() );
	if ( p.mask() )
	    setMask( *p.mask() );
    }
}

void PhotoForm::mousePressEvent( QMouseEvent *e )
{
    if (e->button() == RightButton)
	close();
    clickPos = e->pos();
}

void PhotoForm::mouseMoveEvent( QMouseEvent *e )
{
    move( e->globalPos() - clickPos );
}

void PhotoForm::keyPressEvent(QKeyEvent *e)
{
    if (e->key() == Key_Escape)
	close();
    QWidget::keyPressEvent(e);
}
