/****************************************************************************
                          recvform.ui.h  -  description
                             -------------------
    begin                : Fri May 5 20:12:45 EST 2006
    copyright            : (C) 2004-2007 by Sergey Litvinov
    email                : linch@adsl.by
 ****************************************************************************/

/****************************************************************************
 *                                                                         					   		*
 *   This program is free software; you can redistribute it and/or modify  		   	*
 *   it under the terms of the GNU General Public License as published by  		   	*
 *   the Free Software Foundation; either version 2 of the License, or     		   	*
 *   (at your option) any later version.                                   				   	*
 *                                                                         					   		*
 ****************************************************************************/

void RecvForm::setup(const QString &sender, const QString &fpath, Q_ULONG fsize)
{
    setWFlags(Qt::WDestructiveClose | getWFlags());
    setCaption(sender + tr(" -> file receiving"));
    FileNameLabel->setText(fpath);
    FileSizeLabel->setText(Conversions::bytes2str(fsize));
}

void RecvForm::updateProgressBar(Q_UINT32 progress)
{
    FileProgress->setProgress(progress);
}

void RecvForm::closeEvent(QCloseEvent *event)
{
    emit cancel();
}

void RecvForm::setCurrentFileNumber(Q_ULONG n, Q_ULONG t)
{
    FileNumberLabel->setText('[' + QString::number(n) + '/' + QString::number(t) + ']');   
}

void RecvForm::setFileName(const QString &fpath)
{
    FileNameLabel->setText(fpath);
}

void RecvForm::setFileSize(Q_ULONG fsize)
{
    FileSizeLabel->setText(Conversions::bytes2str(fsize));
}

void RecvForm::setAction(const QString& act)
{
    ActionLabel->setText(act);
}
