/***************************************************************************
                          sendmessagedlg.ui.h  -  description
                             -------------------
    begin                : Sun Dec 19 14:57:00 EST 2004
    copyright            : (C) 2004-2007 by Sergey Litvinov
    email                : linch@adsl.by
 ***************************************************************************/

/***************************************************************************
 *                                                                         					   *
 *   This program is free software; you can redistribute it and/or modify  		   *
 *   it under the terms of the GNU General Public License as published by  		   *
 *   the Free Software Foundation; either version 2 of the License, or     		   *
 *   (at your option) any later version.                                   				   *
 *                                                                         					   *
 ***************************************************************************/


void SendMessageDlg::init()
{
    menu = new QPopupMenu(this);
    for (int i = 0; i <= SM_SLEEP; i++) 
	menu->insertItem(QIconSet(QPixmap::fromMimeSource(smilespack[i].file)), QString(smilespack[i].smile).replace("&", "&&"), i);
    connect(menu, SIGNAL(activated(int)), this, SLOT(menuAction(int)));
    
    listmenu = new QPopupMenu(this);
    listmenu->insertItem(tr("Select all"), 1);
    listmenu->insertItem(tr("Clear selections"), 0);
    connect(listmenu, SIGNAL(activated(int)), this, SLOT(listMenuAction(int)));
    connect(UsersList, SIGNAL(contextMenuRequested(QListBoxItem *, const QPoint &)), this, SLOT(popupListMenu(QListBoxItem*, const QPoint &)));
}

void SendMessageDlg::menuAction(int i)
{
    messageedit->insert(smilespack[i].smile);
}

void SendMessageDlg::smileButtonClicked()
{
    menu->popup(QCursor::pos());
}

void SendMessageDlg::setup(const QString &nick, const QStringList &nicks, const QString &ctext, bool mass, const QStringList &mnicks)
{
    QString tmp = ctext;
    UsersList->insertStringList(nicks);
    
    if (mass)
    {
	UsersList->selectAll(true);
	UsersList->setSelected(nicks.findIndex(nick), false);
    }
    else 
    {
	if (mnicks[0].isEmpty())
	{
	    UsersList->setSelected(nicks.findIndex(nick), true);
	    UsersList->setCurrentItem(nicks.findIndex(nick));
	    UsersList->ensureCurrentVisible();
	}
	else
	{
	    for (uint i = 0; i < mnicks.count(); i++)	
		UsersList->setSelected(nicks.findIndex(mnicks[i]), true);
	    UsersList->setCurrentItem(nicks.findIndex(mnicks[0]));
	    UsersList->ensureCurrentVisible();
	}
    }
    if (!ctext.isEmpty()) 
    {
	tmp.replace(QChar('\n'), "\n>");
	messageedit->setText("\n> " + tmp);
	messageedit->moveCursor(QTextEdit::MoveHome, false);
    }
    updateCaption();
//    messageedit->setFocus();
}

void SendMessageDlg::updateCaption()
{
    QStringList n;
    
    for (uint i = 0; i < UsersList->count(); i++)
	if (UsersList->isSelected(i))
	    n.append(UsersList->text(i));
    setCaption(tr("Message --> ") + n.join(","));
}

void SendMessageDlg::sendPressed()
{
    if (!messageedit->text().isEmpty())
    {
	QStringList n;

	for (uint i = 0; i < UsersList->count(); i++)
	    if (UsersList->isSelected(i))
		 n.append(UsersList->text(i));
	emit send(n, messageedit->text());
    }
    close();
}


void SendMessageDlg::popupListMenu( QListBoxItem *, const QPoint & p)
{
    listmenu->popup(p);    
}

void SendMessageDlg::listMenuAction(int act)
{
    UsersList->selectAll(act);
}
