#include "status.h"
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qlayout.h>

StatusForm::StatusForm(QWidget *parent, const QString &name, const QString &answer): QWidget(NULL)
{
	setWFlags(Qt::WDestructiveClose | Qt::WShowModal | getWFlags());
	
	move(parent->width() /2 - 130, parent->height()/2);

	setCaption(name);
	
	answerline = new QLineEdit(answer, this);
	answerline->setMinimumWidth(450);
	
	b_ok = new QPushButton("OK", this);
	
	QBoxLayout *l1 = new QHBoxLayout(this);
	l1->addWidget(answerline);
	
	l1->addStretch(20);
	l1->addWidget(b_ok);
	b_ok->setAccel(QKeySequence("Return"));
	connect(b_ok, SIGNAL(clicked()), this, SLOT(accept()));
}

StatusForm::~StatusForm()
{
}

void StatusForm::accept()
{
	emit changeStatus(answerline->text());
	close();
}
